// Browser.h : Declaration of the CBrowser
// Written by Alex Ivanov
// Copyright (C) 2004

#ifndef __BROWSER_H_
#define __BROWSER_H_

#include "resource.h"       // main symbols
#include <tchar.h>
#include <docobj.h>
#include <exdisp.h>

/////////////////////////////////////////////////////////////////////////////
// CBrowser
class ATL_NO_VTABLE CBrowser : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CBrowser, &CLSID_Browser>,
	public IDispatchImpl<IBrowser, &IID_IBrowser, &LIBID_ALEKSOFTNAVIGATORLib>,
	public IObjectWithSiteImpl<CBrowser>,
	public IOleCommandTarget 
{
public:
	CBrowser();
	HRESULT FinalConstruct();

DECLARE_REGISTRY_RESOURCEID(IDR_BROWSER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CBrowser)
	COM_INTERFACE_ENTRY(IBrowser)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IObjectWithSite)
	COM_INTERFACE_ENTRY(IOleCommandTarget)
END_COM_MAP()


// IBrowser
public:
LRESULT OnClick(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	STDMETHOD(GetSite)(/*[in]*/ REFIID priid, /*[in,out]*/ void* ppvObj);
	STDMETHOD(SetSite)(/*[in]*/ IUnknown* pSite);
	STDMETHOD(QueryStatus)(const GUID* pGuid,ULONG cCmds,_tagOLECMD prgCmd[],OLECMDTEXT* pCmdTxt);
	STDMETHOD(Exec)(const GUID* pGuid,DWORD nCmdID,DWORD nCmdExecOpt,VARIANT* pvaIn,VARIANT* pvaOut);
private:
	HWND hWndApp,hDlg;
	LPDISPATCH m_pDisp;
	CComQIPtr<IOleCommandTarget, &IID_IOleCommandTarget> m_spDefaultOleCommandTarget;
	IUnknown* m_pSite;
	IWebBrowser2* m_pWb;
	void GoToSite(BSTR bstrUrl);
	void ShowDlg();
	void GotoPrev();
	void GotoNext();
	FILE* m_pFile;//Handle to data file
	BSTR m_pBuffer;//multi purpose string buffer
	int m_pCurrentPos;//currently shown site

	static BOOL CALLBACK DlgProc(
		HWND hwndDlg,  // handle to dialog box
		UINT uMsg,     // message
		WPARAM wParam, // first message parameter
		LPARAM lParam  // second message parameter
		);
	static LRESULT CALLBACK WindowProc(
	  HWND hwnd,      // handle to window
	  UINT uMsg,      // message identifier
	  WPARAM wParam,  // first message parameter
	  LPARAM lParam   // second message parameter
	);
};
static long statCB; //Can't access dynamic pointers from static function directly, casting it as long

#endif //__BROWSER_H_
